

	import ibm.cics.jgate.client.*;
	import java.io.*;
	import java.util.*;
	import java.awt.*;
	import java.awt.event.*;
	import java.applet.Applet;

/**
 * Sample Java GUI Front-end to CICS ECI callable program.
 * This Java program is a follow-on to the series of SolutionPacs from
 * Jim MacNair.  Jim's CA03 SolutionPac describes technology to convert 
 * a CICS BMS oriented program to an ECI callable program.  Ji
 *
 * @version %I%,%G%
 * @author Dennis Weiand
 */

//************************************************************************************
/**
 *  The applet class
 */
//************************************************************************************
public class IVPApplet extends Applet 
                implements ActionListener {

 // -- Instance variables
  String applName = "IVPApplet";            // the application name to print in messages
  
 // -- pertaining to the CICS Java Gateway:
  JavaGateway CICSGatewayConnection = null; // the CICS Java Gateway Object
  String strJGateName = null;               // the CICS Java Gateway location
  int iJGatePort;                           // the CICS Java Gateway Port
  String strServerName = null;              // the target CICS region
  boolean bCheckStatus = true;              // should we check the CICS Client and Server Status?
  ECIRequest eciRequest;                    // the ECI request block object
  String strSignProg = "VERIFYPW";          // name of signon program
  String strRegularProg = "NEWCALL";        // name of inquire, add, update program
  String strBrowseProg = "NEWCBRW";         // name of browse program
  String strAuthenticatedUserId = null;     // userid field
  String strAuthenticatedPassword = null;   
  String strUserId = "FRED";                  // userid for eci request
  String strPassword = "FRED";                // password for CICS userid
  byte[] bTempCommarea;

 // pertaining to the display panels 
  String sTypeAction = "";
  String sBrowseDirection = ""; 
  String mdAccountID = null;                // String for the account identifier
  Label information = new Label("                                                     "); // Area for information messages
  TextField acctNumber = null;         // Text area to receive requested application sysid
  TextField signonUserIdTextField;
  TextField signonPasswordTextField;

  Button addAcctButton;                     // Add button
  Button addCancelButton;
  Button addActionButton;
  Button updAcctButton;                     // Update Button
  Button updCancelButton;
  Button inqAcctButton;                     // Inquire Button
  Button inqReturnButton;
  Button brwAcctButton;                     // Browse Button
  Button brwReturnButton;
  Button brwForwardButton;
  Button brwPreviousButton;
  Button signonButton;                      // Signon Button
  Button signoffButton;

  Panel cardPanel;

  Label addPanelHeader = new Label("");
  Label inqAcctNumberLabel = new Label("");
  Label acctNumberLabel = new Label("");
  Label acctNameLabel = new Label("");
  Label acctAddressLabel = new Label("");
  Label acctPhoneLabel = new Label("");
  Label acctDateLabel = new Label("");
  Label acctAmountLabel = new Label("");
  Label acctCommentLabel = new Label("");

  Label browseNum1Label = new Label("", Label.CENTER);
  Label browseNam1Label = new Label("", Label.CENTER);
  Label browseAmt1Label = new Label("", Label.CENTER);
  Label browseNum2Label = new Label("", Label.CENTER);
  Label browseNam2Label = new Label("", Label.CENTER);
  Label browseAmt2Label = new Label("", Label.CENTER);
  Label browseNum3Label = new Label("", Label.CENTER);
  Label browseNam3Label = new Label("", Label.CENTER);
  Label browseAmt3Label = new Label("", Label.CENTER);
  Label browseNum4Label = new Label("", Label.CENTER);
  Label browseNam4Label = new Label("", Label.CENTER);
  Label browseAmt4Label = new Label("", Label.CENTER);

  TextField acctNameTextField = new TextField("", 20);
  TextField acctAddressTextField = new TextField("", 20);
  TextField acctPhoneTextField = new TextField("", 8);
  TextField acctDateTextField = new TextField("", 8);
  TextField acctAmountTextField = new TextField("", 8);
  TextField acctCommentTextField = new TextField("",9);

  //-- COMMAREA layout for the newcall program
	String[] newcallCommareaDescription = {
	//---> type C=Character, N=display number, MFL=map field length
	//--->    fld Name   type  len  initial value
	//--->  ------------ ----  ---  -----------------
		"USRTRNID",  "C",  "4",  "",
		"USRTRMID",  "C",  "4",  "",
		"NXTRNID",   "C",  "4",  "",
		"MAPNAME",   "C",  "8",  "",
		"RETCODE",   "N",  "8",  "",
		"USRMAPLN",  "N",  "4",  "",
		"USRCPOSN",  "N",  "4",  "",
		"USRCALEN",  "N",  "5",  "",
		"USRAID",    "C",  "1",  "",
		"ERASESW",   "C",  "1",  "",
		"FILLER1",   "C", "37",  "",
		"TEXTAREA",  "C","100",  "",
		"STAT",      "C",  "1",  "",
		"NUMB",      "C",  "6",  "",
		"NAMEX",     "C", "20",  "",
		"ADDRX",     "C", "20",  "",
		"PHONE",     "C",  "8",  "",
		"DATEX",     "C",  "8",  "",
		"AMOUNT",    "C",  "8",  "",
		"COMMENT",   "C",  "9",  "",
		"FILLER2",   "C", "12",  "",
		"MSGL",    "MFL",  "2",  "",
		"MSGA",      "C",  "1",  "",
		"MSGI",      "C", "39",  "",
		"KEYL",    "MFL",  "2",  "",
		"KEYA",      "C",  "1",  "",
		"KEYI",      "C",  "6",  "",
		"FILLER3",   "C", "12",  "",
		"TITLEL",  "MFL",  "2",  "",
		"TITLEA",    "C",  "1",  "",
		"TITLEI",    "C", "12",  "",
		"NUMBL",   "MFL",  "2",  "",
		"NUMBA",     "C",  "1",  "",
		"NUMBI",     "C",  "6",  "",
		"NAMEL",   "MFL",  "2",  "",
		"NAMEA",     "C",  "1",  "",
		"NAMEI",     "C", "20",  "",
		"ADDRL",   "MFL",  "2",  "",
		"ADDRA",     "C",  "1",  "",
		"ADDRI",     "C", "20",  "",
		"PHONEL",  "MFL",  "2",  "",
		"PHONEA",    "C",  "1",  "",
		"PHONEI",    "C",  "8",  "",
		"DATEL",   "MFL",  "2",  "",
		"DATEA",     "C",  "1",  "",
		"DATEI",     "C",  "8",  "",
		"AMOUNTL", "MFL",  "2",  "",
		"AMOUNTA",   "C",  "1",  "",
		"AMOUNTI",   "C",  "8",  "",
		"COMMENTL","MFL",  "2",  "",
		"COMMENTA",  "C",  "1",  "",
		"COMMENTI",  "C",  "9",  "",
		"MSG1L",   "MFL",  "2",  "",
		"MSG1A",     "C",  "1",  "",
		"MSG1I",     "C", "39",  "",
		"MSG3L",   "MFL",  "2",  "",
		"MSG3A",     "C",  "1",  "",
		"MSG3I",     "C", "39",  "",
		"END-OF-ITEMS" };
	Commarea newcallCommarea = new Commarea(newcallCommareaDescription);

  // -- COMMAREA layout for the newcbrw program
	String[] newcbrwCommareaDescription = {
	//---> type C=Character, N=display number, MFL=map field length
	//--->    fld Name   type  len  initial value
	//--->  ------------ ----  ---  -----------------
		"USRTRNID",  "C",  "4",  "",
		"USRTRMID",  "C",  "4",  "",
		"NXTRNID",   "C",  "4",  "",
		"MAPNAME",   "C",  "8",  "",
		"RETCODE",   "N",  "8",  "",
		"USRMAPLN",  "N",  "4",  "",
		"USRCPOSN",  "N",  "4",  "",
		"USRCALEN",  "N",  "5",  "",
		"USRAID",    "C",  "1",  "",
		"ERASESW",   "C",  "1",  "",
		"FILLER1",   "C", "37",  "",
		"TEXTAREA",  "C","100",  "",
		"CURROP",    "C",  "1",  "",
		"LASTOP",    "C",  "1",  "",
		"RIDF",      "N",  "6",  "",
		"RIDB",      "N",  "6",  "",
		"FILLER2",   "C", "12",  "",
		"MSGL",    "MFL",  "2",  "",
		"MSGA",      "C",  "1",  "",
		"MSGI",      "C", "39",  "",
		"KEYL",    "MFL",  "2",  "",
		"KEYA",      "C",  "1",  "",
		"KEYI",      "C",  "6",  "",
		"FILLER3",   "C", "12",  "",
		"DIRL",    "MFL",  "2",  "",
		"DIRA",      "C",  "1",  "",
		"DIRI",      "C",  "1",  "",
		"NUMBER1L","MFL",  "2",  "",
		"NUMBER1A",  "C",  "1",  "",
		"NUMBER1I",  "C",  "6",  "",
		"NAME1L",  "MFL",  "2",  "",
		"NAME1A",    "C",  "1",  "",
		"NAME1I",    "C", "20",  "",
		"AMOUNT1L","MFL",  "2",  "",
		"AMOUNT1A",  "C",  "1",  "",
		"AMOUNT1I",  "C",  "8",  "",
		"NUMBER2L","MFL",  "2",  "",
		"NUMBER2A",  "C",  "1",  "",
		"NUMBER2I",  "C",  "6",  "",
		"NAME2L",  "MFL",  "2",  "",
		"NAME2A",    "C",  "1",  "",
		"NAME2I",    "C", "20",  "",
		"AMOUNT2L","MFL",  "2",  "",
		"AMOUNT2A",  "C",  "1",  "",
		"AMOUNT2I",  "C",  "8",  "",
		"NUMBER3L","MFL",  "2",  "",
		"NUMBER3A",  "C",  "1",  "",
		"NUMBER3I",  "C",  "6",  "",
		"NAME3L",  "MFL",  "2",  "",
		"NAME3A",    "C",  "1",  "",
		"NAME3I",    "C", "20",  "",
		"AMOUNT3L","MFL",  "2",  "",
		"AMOUNT3A",  "C",  "1",  "",
		"AMOUNT3I",  "C",  "8",  "",
		"NUMBER4L","MFL",  "2",  "",
		"NUMBER4A",  "C",  "1",  "",
		"NUMBER4I",  "C",  "6",  "",
		"NAME4L",  "MFL",  "2",  "",
		"NAME4A",    "C",  "1",  "",
		"NAME4I",    "C", "20",  "",
		"AMOUNT4L","MFL",  "2",  "",
		"AMOUNT4A",  "C",  "1",  "",
		"AMOUNT4I",  "C",  "8",  "",
		"MSG0L",   "MFL",  "2",  "",
		"MSG0A",     "C",  "1",  "",
		"MSG0I",     "C", "39",  "",
		"MSG1L",   "MFL",  "2",  "",
		"MSG1A",     "C",  "1",  "",
		"MSG1I",     "C", "39",  "",
		"MSG2L",   "MFL",  "2",  "",
		"MSG2A",     "C",  "1",  "",
		"MSG2I",     "C", "39",  "",
		"END-OF-ITEMS" };
	Commarea newcbrwCommarea = new Commarea(newcbrwCommareaDescription);
		

/*********************************************************************************/
/*   for debugging                                                               */
/*********************************************************************************/
    private static void printMsg(String s) {
	System.out.println(s);
    }

/*********************************************************************************/
/**  The init method is the first method invoked by the browser                  */
/*      we will use it to construct the panels (only module directory at this time*/
/*********************************************************************************/
  public void init() {
    printMsg(applName+": Init method entered");
    getAppletContext().showStatus("CICS IVP Java Applet");    // write on the browser status line
    printMsg(applName+": -> General Information:");
    printMsg(applName+": ---> Protocol: "+getDocumentBase().getProtocol());
    if (getDocumentBase().getProtocol().equals("file")) {
      printMsg(applName+": ---> File: "+getDocumentBase().getFile());
    } else {
      printMsg(applName+": ---> URL:  "+getDocumentBase());
      printMsg(applName+": ---> Host: "+getDocumentBase().getHost());
      printMsg(applName+": ---> Port: "+getDocumentBase().getPort());
    }

   //--------------------------------------------------------------------------------
   // - print parms passed to this applet
    printMsg(applName+": -> getting parms");
    try { iJGatePort = Integer.parseInt(getParameter("port")); } 
    catch (NumberFormatException e) { iJGatePort = 2006; }
    printMsg(applName+": ---> port = "+iJGatePort);     
    strJGateName = getParameter("gateway");
    printMsg(applName+": ---> gateway = "+strJGateName);
    strServerName = getParameter("server");
    printMsg(applName+": ---> server = "+strServerName);
    //strProgName = getParameter("program");
    //printMsg(applName+": ---> program = "+strProgName);
    //strUserId = getParameter("userid");
    //printMsg(applName+": ---> userid = "+strUserId);
    //strPassword = getParameter("password");
    //printMsg(applName+": ---> password = "+strPassword);

   //--------------------------------------------------------------------------------
   // - build the GUI panels
    printMsg(applName+": -> building panels");
    setLayout(new BorderLayout());

   //---------------------------------------------------------------------------------
   // information area in main panel
    add("South", information);

   //---------------------------------------------------------------------------------
   // headings with appropriate font
    Panel northPan = new Panel(new FlowLayout());
    Label lNPMainHeader = new Label("IVP:");
    lNPMainHeader.setFont(new Font("dialog", 3, 24));
    northPan.add(lNPMainHeader);
    Label lNPMainHeader2 = new Label("Account Maintenance");
    lNPMainHeader2.setFont(new Font("dialog", 2, 18));
    northPan.add(lNPMainHeader2);
    add("North", northPan);

   //---------------------------------------------------------------------------------
   // message panel accross the bottom
    add("South", information);

   //---------------------------------------------------------------------------------
   // - the following is a series of 'card' panels that represent the various
   // - panels of the IVP
   //---------------------------------------------------------------------------------
   // create signon panel
    printMsg(applName+": ---> building signon panel");
    Panel signonPanel = new Panel(new BorderLayout());
    signonPanel.add("North", new Label("Enter signon details and press the signon button"));
    Panel signonSouthPanel = new Panel(new FlowLayout());
    signonButton = new Button("signon");
    signonButton.addActionListener(this);
    signonSouthPanel.add(signonButton);
    signonPanel.add("South", signonSouthPanel);

    Panel signonCenterPanel = new Panel(new GridLayout(7, 2));
    signonCenterPanel.add(new Label(" "));
    signonCenterPanel.add(new Label(" "));
    signonCenterPanel.add(new Label(" "));
    signonCenterPanel.add(new Label(" "));
    Panel signonGridPanel1 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    signonGridPanel1.add(new Label("User id:"));
    signonCenterPanel.add(signonGridPanel1);
    Panel signonGridPanel11 = new Panel(new FlowLayout(FlowLayout.LEFT));
    signonUserIdTextField = new TextField("", 8);
    signonGridPanel11.add(signonUserIdTextField);
    signonCenterPanel.add(signonGridPanel11);
    Panel signonGridPanel2 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    signonGridPanel2.add(new Label("Password:"));
    signonCenterPanel.add(signonGridPanel2);
    Panel signonGridPanel12 = new Panel(new FlowLayout(FlowLayout.LEFT));
    signonPasswordTextField = new TextField("",8);
    signonGridPanel12.add(signonPasswordTextField);
    signonCenterPanel.add(signonGridPanel12);
    signonPanel.add("Center", signonCenterPanel);
 
  //-------------------------------------------------------------------------
  // build function selection Panel
    printMsg(applName+": ---> building main panel");
    Panel mainPanel = new Panel(new GridLayout(7,1));
    Panel mainGridPanel1 = new Panel(new FlowLayout());
    mainGridPanel1.add(new Label("Account Identifier:"));
    acctNumber = new TextField("",6);
    mainGridPanel1.add(acctNumber);
    mainPanel.add(mainGridPanel1);
    Panel mainGridPanel2 = new Panel(new FlowLayout());
    inqAcctButton = new Button("Inquire");
    inqAcctButton.addActionListener(this);
    mainGridPanel2.add(inqAcctButton);
    addAcctButton = new Button(" Add ");
    addAcctButton.addActionListener(this);
    mainGridPanel2.add(addAcctButton);
    updAcctButton = new Button("Update");
    updAcctButton.addActionListener(this);
    mainGridPanel2.add(updAcctButton);
    brwAcctButton = new Button("Browse");
    brwAcctButton.addActionListener(this);
    mainGridPanel2.add(brwAcctButton);
    signoffButton = new Button("Signoff");
    signoffButton.addActionListener(this);
    mainGridPanel2.add(signoffButton);
    mainPanel.add(mainGridPanel2);

  //------------------------------------------------------------------
  // build inquiry panel
    printMsg(applName+": ---> building inquiry panel");
    Panel inquiryPanel = new Panel(new BorderLayout());
    Panel inquiryPanelC = new Panel(new GridLayout(10,2));
    inquiryPanelC.add(new Label("Account Details:"));
    inquiryPanelC.add(new Label(""));
    Panel inqGridPanel1 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    inqGridPanel1.add(new Label("Account Number:"));
    inquiryPanelC.add(inqGridPanel1);
    Panel inqGridPanel11 = new Panel(new FlowLayout(FlowLayout.LEFT));
    inqGridPanel11.add(inqAcctNumberLabel);
    inquiryPanelC.add(inqGridPanel11);
    Panel inqGridPanel2 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    inqGridPanel2.add(new Label("Name:"));
    inquiryPanelC.add(inqGridPanel2);
    Panel inqGridPanel12 = new Panel(new FlowLayout(FlowLayout.LEFT));
    inqGridPanel12.add(acctNameLabel);
    inquiryPanelC.add(inqGridPanel12);
    Panel inqGridPanel3 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    inqGridPanel3.add(new Label("Address:"));
    inquiryPanelC.add(inqGridPanel3);
    Panel inqGridPanel13 = new Panel(new FlowLayout(FlowLayout.LEFT));
    inqGridPanel13.add(acctAddressLabel);
    inquiryPanelC.add(inqGridPanel13);
    Panel inqGridPanel4 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    inqGridPanel4.add(new Label("Phone:"));
    inquiryPanelC.add(inqGridPanel4);
    Panel inqGridPanel14 = new Panel(new FlowLayout(FlowLayout.LEFT));
    inqGridPanel14.add(acctPhoneLabel);
    inquiryPanelC.add(inqGridPanel14);
    Panel inqGridPanel5 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    inqGridPanel5.add(new Label("Date:"));
    inquiryPanelC.add(inqGridPanel5);
    Panel inqGridPanel15 = new Panel(new FlowLayout(FlowLayout.LEFT));
    inqGridPanel15.add(acctDateLabel);
    inquiryPanelC.add(inqGridPanel15);
    Panel inqGridPanel6 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    inqGridPanel6.add(new Label("Amount:"));
    inquiryPanelC.add(inqGridPanel6);
    Panel inqGridPanel16 = new Panel(new FlowLayout(FlowLayout.LEFT));
    inqGridPanel16.add(acctAmountLabel);
    inquiryPanelC.add(inqGridPanel16);
    Panel inqGridPanel7 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    inqGridPanel7.add(new Label("Comment:"));
    inquiryPanelC.add(inqGridPanel7);
    Panel inqGridPanel17 = new Panel(new FlowLayout(FlowLayout.LEFT));
    inqGridPanel17.add(acctCommentLabel);
    inquiryPanelC.add(inqGridPanel17);
    inquiryPanel.add("Center", inquiryPanelC);
    Panel inqButtonPanel = new Panel(new FlowLayout());
    inqReturnButton = new Button("Return");
    inqReturnButton.addActionListener(this);
    inqButtonPanel.add(inqReturnButton);
    inquiryPanel.add("South", inqButtonPanel);


  //------------------------------------------------------------------
  // build addd/update panel
    printMsg(applName+": ---> building add/update panel");
    Panel addPanel = new Panel(new BorderLayout());
    Panel addPanelC = new Panel(new GridLayout(10,2));
    addPanelC.add(addPanelHeader);
    addPanelC.add(new Label(""));
    Panel addGridPanel1 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    addGridPanel1.add(new Label("Account Number:"));
    addPanelC.add(addGridPanel1);
    Panel addGridPanel11 = new Panel(new FlowLayout(FlowLayout.LEFT));
    addGridPanel11.add(acctNumberLabel);
    addPanelC.add(addGridPanel11);
    Panel addGridPanel2 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    addGridPanel2.add(new Label("Name:"));
    addPanelC.add(addGridPanel2);
    Panel addGridPanel12 = new Panel(new FlowLayout(FlowLayout.LEFT));
    addGridPanel12.add(acctNameTextField);
    addPanelC.add(addGridPanel12);
    Panel addGridPanel3 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    addGridPanel3.add(new Label("Address:"));
    addPanelC.add(addGridPanel3);
    Panel addGridPanel13 = new Panel(new FlowLayout(FlowLayout.LEFT));
    addGridPanel13.add(acctAddressTextField);
    addPanelC.add(addGridPanel13);
    Panel addGridPanel4 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    addGridPanel4.add(new Label("Phone:"));
    addPanelC.add(addGridPanel4);
    Panel addGridPanel14 = new Panel(new FlowLayout(FlowLayout.LEFT));
    addGridPanel14.add(acctPhoneTextField);
    addPanelC.add(addGridPanel14);
    Panel addGridPanel5 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    addGridPanel5.add(new Label("Date:"));
    addPanelC.add(addGridPanel5);
    Panel addGridPanel15 = new Panel(new FlowLayout(FlowLayout.LEFT));
    addGridPanel15.add(acctDateTextField);
    addPanelC.add(addGridPanel15);
    Panel addGridPanel6 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    addGridPanel6.add(new Label("Amount:"));
    addPanelC.add(addGridPanel6);
    Panel addGridPanel16 = new Panel(new FlowLayout(FlowLayout.LEFT));
    addGridPanel16.add(acctAmountTextField);
    addPanelC.add(addGridPanel16);
    Panel addGridPanel7 = new Panel(new FlowLayout(FlowLayout.RIGHT));
    addGridPanel7.add(new Label("Comment:"));
    addPanelC.add(addGridPanel7);
    Panel addGridPanel17 = new Panel(new FlowLayout(FlowLayout.LEFT));
    addGridPanel17.add(acctCommentTextField);
    addPanelC.add(addGridPanel17);
    addPanel.add("Center", addPanelC);
    Panel addButtonPanel = new Panel(new FlowLayout());
    addActionButton = new Button("Add");
    addActionButton.addActionListener(this);
    addButtonPanel.add(addActionButton);
    addCancelButton = new Button("Cancel");
    addCancelButton.addActionListener(this);
    addButtonPanel.add(addCancelButton);
    addPanel.add("South", addButtonPanel);

  //------------------------------------------------------------------
  // build Browse panel
    printMsg(applName+": ---> building browse panel");
    Panel browsePanel = new Panel(new BorderLayout());
    Panel browsePanelC = new Panel(new GridLayout(8,3));
    browsePanelC.add(new Label("Number", Label.CENTER));
    browsePanelC.add(new Label("Name", Label.CENTER));
    browsePanelC.add(new Label("Amount", Label.CENTER));
    browsePanelC.add(new Label("--------", Label.CENTER));
    browsePanelC.add(new Label("------", Label.CENTER));
    browsePanelC.add(new Label("--------", Label.CENTER));
    browsePanelC.add(browseNum1Label);
    browsePanelC.add(browseNam1Label);
    browsePanelC.add(browseAmt1Label);
    browsePanelC.add(browseNum2Label);
    browsePanelC.add(browseNam2Label);
    browsePanelC.add(browseAmt2Label);
    browsePanelC.add(browseNum3Label);
    browsePanelC.add(browseNam3Label);
    browsePanelC.add(browseAmt3Label);
    browsePanelC.add(browseNum4Label);
    browsePanelC.add(browseNam4Label);
    browsePanelC.add(browseAmt4Label);
    browsePanel.add("Center", browsePanelC);

    Panel brwButtonPanel = new Panel(new FlowLayout());
    brwReturnButton = new Button("Return");
    brwReturnButton.addActionListener(this);
    brwButtonPanel.add(brwReturnButton);
    brwForwardButton = new Button("Forward");
    brwForwardButton.addActionListener(this);
    brwButtonPanel.add(brwForwardButton);
    brwPreviousButton = new Button("Previous");
    brwPreviousButton.addActionListener(this);
    brwButtonPanel.add(brwPreviousButton);
    browsePanel.add("South", brwButtonPanel);


  //-------------------------------------------------------------------------
  // add the individual panels to the card panel
    cardPanel = new Panel(new CardLayout());
    cardPanel.add("signon", signonPanel);
    cardPanel.add("main", mainPanel);
    cardPanel.add("inquiry", inquiryPanel);
    cardPanel.add("add", addPanel);
    cardPanel.add("browse", browsePanel);

    add("Center", cardPanel);
    

  //-------------------------------------------------------------------------
  // - show the signon panel first 
    ((CardLayout)cardPanel.getLayout()).show(cardPanel, "signon");
    signonUserIdTextField.requestFocus();        // put the cursor in the userid field
    signonPasswordTextField.setEchoChar('*');    // make the password non-display

  }

/*********************************************************************************/
/**  The Start method is the second method to get invoked by the browser         */
/*   the start method is invoked when we go 'on page'                            */
/*         we will use it to get a connection to the CICS Java Gateway           */
/*         we will remove the connection when we go 'off page' (this assumes they may not return */
/*********************************************************************************/
  public void start() {
    printMsg(applName+": start method entered");
    connectToGateway();
  }

/*********************************************************************************/
/**  attempt a CICS Java Gateway Connection                                      */
/*********************************************************************************/
  public boolean connectToGateway() {
        if (CICSGatewayConnection != null) {
		printMsg(applName+": CICS Java Gateway connection object is not null.");
                information.setText("Waiting for response...");
		return true;
        }
        
        eciRequest = null;
        printMsg(applName+": Attempting connection to gateway "+strJGateName+", on port "+iJGatePort+".");

        try {
            CICSGatewayConnection = new JavaGateway(strJGateName, iJGatePort);
            printMsg(applName+": Successfully created JavaGateway");

            /* Find out our general state information */
            if (bCheckStatus) {
                printMsg(applName+": --> === General Status ===");
                displayState(null, null);
            }

            /* Find out what systems are available */
            eciRequest = ECIRequest.listSystems(10);
            CICSGatewayConnection.flow(eciRequest);
            printMsg(applName+": --> === Available Servers ===");
            if (eciRequest.getRc() == 0) {
                for (int iSysLoop = 0; iSysLoop < eciRequest.SystemList.size(); iSysLoop += 2) {
                    if (bCheckStatus) {
                        displayState(
                            (String) eciRequest.SystemList.elementAt(iSysLoop),
                            (String) eciRequest.SystemList.elementAt(iSysLoop + 1));
                    }
                    else {
                        printMsg(applName+": ----> " + 
                            (String) eciRequest.SystemList.elementAt(iSysLoop) +
                            ", Description : " +
                            (String) eciRequest.SystemList.elementAt(iSysLoop + 1));
                    }
                }
            }
            else
            {
                System.out.println(applName+": ECIRequest.listSystems failed with Rc : " +
                           eciRequest.getRc());
                information.setText("Communications to Java Gateway failed!");
		return false;
            }
            information.setText("Communications with Java Gateway established.");
            return true;
      }
      catch (IOException e) {
            System.out.println(applName+": Gateway exception: "+e);
            Frame errF = new Frame(applName+" Error");
            Dialog errorD = new ErrPan(errF, "Unable to establish communications with "+strJGateName+" on port "+iJGatePort+".  See Java Console for more info.");
            errF.dispose();
            errF = null;
            CICSGatewayConnection = null;
            information.setText("Could not establish communications to Java Gateway!");
	    return false;
      }
  }

/*********************************************************************************/
/**  This method does an ECI_STATE_SYNC call to check the server status          */
/*********************************************************************************/
    private void displayState(String strServerName, String strServerDescription) 
                                 throws IOException {
        printMsg(applName+": displayState method entered");
        /* Make a getStatus call */
        eciRequest = (new ECIRequest()).getStatus(strServerName);
        CICSGatewayConnection.flow(eciRequest);
        
        /* Display the relevant information */
        if (strServerName == null) {
            if (eciRequest.Cics_Rc != 0) {
                printMsg(applName+": ECI_STATE_SYNC general query failed with return code : " 
                           + eciRequest.Cics_Rc);
            }
            else {
                printMsg(applName+": Connection status: " +
                           eciRequest.stringConnectionType(eciRequest.ConnectionType));
            }
        }
        else {
            printMsg(applName+": " + strServerName +
                       ", Description: " + strServerDescription);
            printMsg(applName+"  Server status: " +
                       eciRequest.stringServerStatus(eciRequest.CicsServerStatus));
            printMsg(applName+"  Client status: " +
                       eciRequest.stringClientStatus(eciRequest.CicsClientStatus));

        }
    }

/*********************************************************************************/
/**  The stop method is invoked when our application goes off page               */
/*    when we go off page, we will close the CICS java gateway                   */
/*********************************************************************************/
  public void stop() {
    printMsg(applName+": stop method entered");
    try {
        if (CICSGatewayConnection != null) {
           CICSGatewayConnection.close();
           printMsg(applName+"-stop: CICS Java Gateway "+strJGateName+" closed.");
           CICSGatewayConnection = null;
        }
    }
    catch (IOException eClose) {
    }
  }

/*********************************************************************************/
/*   the destroy method is invoked when the applet is terminated,                */
/*      so close the CICS gateway for java connection if it exists               */
/*********************************************************************************/
  public void destory() {
    printMsg(applName+": destroy method entered");
    try {
        if (CICSGatewayConnection != null) {
           CICSGatewayConnection.close();
           printMsg(applName+"-stop: CICS Java Gateway "+strJGateName+" closed.");
           CICSGatewayConnection = null;
        }
    }
    catch (IOException eClose) {
    }
  }

/*********************************************************************************/
/*  Handle events here   (test for the various buttons)                          */
/*********************************************************************************/
  public void actionPerformed(ActionEvent e) {          //-inquire button
    if (e.getSource() == inqAcctButton) {
      printMsg(applName+": Inquire button pressed");
      if (acctNumberIs6Positions()) {
        sTypeAction = "INQY";
        inqAcctInfo();
      }
    }
    else if (e.getSource() == inqReturnButton) {          //-inquire-return button
      printMsg(applName+": return button pressed on inquiry panel");
      information.setText("Enter account code and press appropriate button");
      acctNumber.setText("");
      acctNumber.requestFocus();
      ((CardLayout)cardPanel.getLayout()).show(cardPanel, "main");
    }
    else if (e.getSource() == addAcctButton) {          //-add account button
      printMsg(applName+": add button was pressed");
      if (acctNumberIs6Positions()) {
        addAcctInfo();
      }
    }
    else if (e.getSource() == addActionButton) {          //-add-action button
      printMsg(applName+": action button on add/update panel was pressed");
      addActionInfo();
    }
    else if (e.getSource() == addCancelButton) {          //-add-cancel button
      printMsg(applName+": Cancel button on add panel was pressed");
      information.setText("Enter account code and press appropriate button");
      acctNumber.setText("");
      acctNumber.requestFocus();
      ((CardLayout)cardPanel.getLayout()).show(cardPanel, "main");
    }
    else if (e.getSource() == updAcctButton) {         //-update button from main menu
      printMsg(applName+": update button was pressed");
      if (acctNumberIs6Positions()) {
        sTypeAction = "UPDT";
        inqAcctInfo();
      }
    }
    else if (e.getSource() == updCancelButton) {          //-update-cancel button pressed
      printMsg(applName+": cancel button on update panel was pressed");
      information.setText("Enter account code and press appropriate button");
      acctNumber.setText("");
      acctNumber.requestFocus();
      ((CardLayout)cardPanel.getLayout()).show(cardPanel, "main");
    }
    else if (e.getSource() == brwAcctButton) {          //-browse button from main menu
      printMsg(applName+": browse button was pressed");
      if (acctNumberIs6Positions()) {
	sBrowseDirection = "Start";
        brwAcctInfo();
      }
    }
    else if (e.getSource() == brwReturnButton) {         //-browse-return button pressed
      printMsg(applName+": return button on browse panel was pressed");
      acctNumber.setText("");
      information.setText("Enter account code and press appropriate button");
      acctNumber.requestFocus();
      ((CardLayout)cardPanel.getLayout()).show(cardPanel, "main");
    }
    else if (e.getSource() == brwForwardButton) {         //-browse-forward button pressed
      printMsg(applName+": forward button on browse panel was pressed");
      sBrowseDirection = "Forward";
      brwAcctInfo();
    }
    else if (e.getSource() == brwPreviousButton) {        //-browse-previous button pressed
      printMsg(applName+": previous button on browse panel was pressed");
      sBrowseDirection = "Backward";
      brwAcctInfo();
    }
    else if (e.getSource() == signonButton) {        //-signon button
      printMsg(applName+":signon button was pressed");
      signonInfo();
    }
    else if (e.getSource() == signoffButton) {        //-signoff button
      printMsg(applName+":signoff button was processed");
      signoffInfo();
    }
  }


 //-----------------------------------------------------------------------------------
 // - verify the account number is 6 positions
  private boolean acctNumberIs6Positions() {
	printMsg(applName+": the account number should be 6 positions, it is " +(acctNumber.getText()).length());
	if ((acctNumber.getText()).length() != 6) {
		printMsg(applName+": the account number was not 6 positions");
		information.setText("You must enter a 6 position account number");
		acctNumber.requestFocus();
		return false;
	}
	try {
		int iTemp = Integer.parseInt(acctNumber.getText());
	} catch (NumberFormatException e) {
		printMsg(applName+": the account number was not 6 positions");
		information.setText("The account number must be numeric");
		acctNumber.requestFocus();
		return false;
	}
	return true;
  }

 //------------------------------------------------------------------------------
 // - they hit the inquiry button, lets go do it
  private void inqAcctInfo() {
    printMsg(applName+": value of accNumber.getText() is "+acctNumber.getText());
    inqAcctNumberLabel.setText(acctNumber.getText());

	if (!connectToGateway()) {
		Frame errF = new Frame(applName+" Error");
		Dialog errorD = new ErrPan(errF, "Cannot connect to the CICS Java Gateway, contact your system support.");
		errF.dispose();
		errF = null;
		information.setText("Problem connecting to the CICS Gateway for Java.");
		return;
	}
    //---------------------------------------------------------------------------
    // - drive the mainframe inquiry program

	//newcallCommarea = new Commarea(newcallCommareaDescription);
	//newcallCommarea.toString();
	newcallCommarea.setValue("KEYI", acctNumber.getText());
	newcallCommarea.setValue("KEYL", "6");
	newcallCommarea.setValue("MAPNAME", "MENU");
	newcallCommarea.setValue("USRCALEN", "0");
	if (sTypeAction.equals("INQY")) {
		//System.out.println("sTypeAction was INQY");
		newcallCommarea.setValue("USRTRNID", "INQY");
	} else {
		//System.out.println("sTypeAction was NOT INQY");
		newcallCommarea.setValue("USRTRNID", "UPDT");
	}
        //System.out.println("-->"+new String(newcallCommarea.theCommarea())+"<--");

	bTempCommarea = newcallCommarea.theCommarea();
	try {
		printMsg(applName+": Trying ECI request for newcall");
		eciRequest = new ECIRequest(strServerName,	// CICS Server
		strAuthenticatedUserId,				// UserId, null for none
		strAuthenticatedPassword,				// Password, null for none
		"NEWCALL",				// Program name
		bTempCommarea,				// Commarea, null for none
		ECIRequest.ECI_NO_EXTEND,		// single call in LUW
		ECIRequest.ECI_LUW_NEW);
		eciRequest.Cics_Rc = 0;
		CICSGatewayConnection.flow(eciRequest);	// flow the ECI request
		printMsg(applName+":  Return code: " + eciRequest.Cics_Rc);
		if (eciRequest.Cics_Rc == 0) {
			newcallCommarea.resetCommareaValues(bTempCommarea);  //return values
			if (((newcallCommarea.getValue("MSGI")).substring(0, 7)).equals("INVALID")) {
				information.setText(newcallCommarea.getValue("MSGI"));
				acctNumber.requestFocus();
				((CardLayout)cardPanel.getLayout()).show(cardPanel, "main");
				eciRequest = null;
				return;
			}
			if ((newcallCommarea.getValue("MAPNAME")).equals("SENDTEXT")) {
				information.setText(newcallCommarea.getValue("TEXTAREA"));
				acctNumber.setText("");
				acctNumber.requestFocus();
				((CardLayout)cardPanel.getLayout()).show(cardPanel, "main");
				eciRequest = null;
				return;
			}
			if (sTypeAction.equals("INQY")) {
				//System.out.println("==> sTypeAction was INQY");
				acctNameLabel.setText(newcallCommarea.getValue("NAMEI"));
				acctAddressLabel.setText(newcallCommarea.getValue("ADDRI"));
				acctPhoneLabel.setText(newcallCommarea.getValue("PHONEI"));
				acctDateLabel.setText(newcallCommarea.getValue("DATEI"));
				acctAmountLabel.setText(newcallCommarea.getValue("AMOUNTI"));
				if ((newcallCommarea.getByteValue("COMMENTI"))[0] != 0x00) {
					acctCommentLabel.setText(newcallCommarea.getValue("COMMENTI"));
				} else {
					acctCommentLabel.setText("");
				}
				inqAcctNumberLabel.setText(newcallCommarea.getValue("NUMBI"));
				information.setText("Account information displayed");
				((CardLayout)cardPanel.getLayout()).show(cardPanel, "inquiry");
			} else {
				//System.out.println("===> sTypeAction was NOT INQY");
				addPanelHeader.setText("Update Record:");
				acctNumberLabel.setText(acctNumber.getText());
				acctNameTextField.setText(newcallCommarea.getValue("NAMEI"));
				acctAddressTextField.setText(newcallCommarea.getValue("ADDRI"));
				acctPhoneTextField.setText(newcallCommarea.getValue("PHONEI"));
				acctDateTextField.setText(newcallCommarea.getValue("DATEI"));
				acctAmountTextField.setText(newcallCommarea.getValue("AMOUNTI"));
				if ((newcallCommarea.getByteValue("COMMENTI"))[0] != 0x00) {
					acctCommentTextField.setText(newcallCommarea.getValue("COMMENTI"));
				} else {
					acctCommentTextField.setText("");
				}
				acctNameTextField.requestFocus();
				addActionButton.setLabel("Update");
				information.setText("OverType the record contents and press update");
				((CardLayout)cardPanel.getLayout()).show(cardPanel, "add");
			}
			//System.out.println("===> setting file area");
			//newcallCommarea.setValue("NUMB", acctNumber.getText());
			//newcallCommarea.setValue("NAMEX", newcallCommarea.getValue("NAMEI"));
			//newcallCommarea.setValue("ADDRX", newcallCommarea.getValue("ADDRI"));
			//newcallCommarea.setValue("PHONE", newcallCommarea.getValue("PHONEI"));
			//newcallCommarea.setValue("DATEX", newcallCommarea.getValue("DATEI"));
			//newcallCommarea.setValue("AMOUNT", newcallCommarea.getValue("AMOUNTI"));
			//newcallCommarea.setValue("COMMENT", newcallCommarea.getValue("COMMENTI"));

		} else {
			information.setText("Password validation problem, please retry.");
			signoffInfo();
		}
		eciRequest = null;
		return;
	}  catch (IOException e) {
		printMsg(applName+": ERROR: " + e);
		try {
			if (CICSGatewayConnection != null) {
				CICSGatewayConnection.close();
				printMsg(applName+"Successfully closed JavaGateway");
				CICSGatewayConnection = null;
			}
		} catch (IOException eClose) {
			printMsg(applName+": Exception during close: " + eClose);
		}
		printMsg(applName+": ECI call exception: "+e);
		information.setText("Problem sending your request to CICS.");
		return;
	}
  }

  private void addAcctInfo() {
    addPanelHeader.setText("Add Record:");
    acctNumberLabel.setText(acctNumber.getText());
    acctNameTextField.setText("");
    acctAddressTextField.setText("");
    acctPhoneTextField.setText("");
    acctDateTextField.setText("");
    acctAmountTextField.setText("");
    acctCommentTextField.setText("");
    acctNameTextField.requestFocus();
    addActionButton.setLabel(" Add ");
    information.setText("Fill in the new record contents and press add");
    ((CardLayout)cardPanel.getLayout()).show(cardPanel, "add");
  }

  private void addActionInfo() {
	if (!connectToGateway()) {
		Frame errF = new Frame(applName+" Error");
		Dialog errorD = new ErrPan(errF, "Cannot connect to the CICS Java Gateway, contact your system support.");
		errF.dispose();
		errF = null;
		information.setText("Problem connecting to the CICS Gateway for Java.");
		return;
	}
    //---------------------------------------------------------------------------
    // - drive the mainframe add or update program

	
	newcallCommarea.setValue("KEYI", acctNumber.getText());
	newcallCommarea.setValue("KEYL", "6");
	newcallCommarea.setValue("MAPNAME", "DETAIL");
	if ((addActionButton.getLabel()).equals("Update")) {
		newcallCommarea.setValue("USRTRNID", "UPDT");
	} else {
		newcallCommarea.setValue("USRTRNID", "ADDS");
	}
	newcallCommarea.setValue("NAMEI", acctNameTextField.getText());
	newcallCommarea.setValue("USRCALEN", "1");
	newcallCommarea.setValue("NUMBI", acctNumber.getText());
	newcallCommarea.setValue("NUMB", acctNumber.getText());
	newcallCommarea.setValue("ADDRI", acctAddressTextField.getText());
	newcallCommarea.setValue("PHONEI", acctPhoneTextField.getText());
	newcallCommarea.setValue("DATEI", acctDateTextField.getText());
	newcallCommarea.setValue("AMOUNTI", acctAmountTextField.getText());
	newcallCommarea.setValue("COMMENTI", acctCommentTextField.getText());
        //System.out.println("-->"+new String(newcallCommarea.theCommarea())+"<--");

	bTempCommarea = newcallCommarea.theCommarea();
	try {
		printMsg(applName+": Trying ECI request for newcall");
		eciRequest = new ECIRequest(strServerName,	// CICS Server
		strAuthenticatedUserId,				// UserId, null for none
		strAuthenticatedPassword,			// Password, null for none
		strRegularProg,					// Program name
		bTempCommarea,					// Commarea, null for none
		ECIRequest.ECI_NO_EXTEND,			// single call in LUW
		ECIRequest.ECI_LUW_NEW);
		eciRequest.Cics_Rc = 0;
		CICSGatewayConnection.flow(eciRequest);	// flow the ECI request
		printMsg(applName+":  Return code: " + eciRequest.Cics_Rc);
		if (eciRequest.Cics_Rc == 0) {
			newcallCommarea.resetCommareaValues(bTempCommarea);  //return values
			if (((newcallCommarea.getValue("MAPNAME")).substring(0,6)).equals("DETAIL")) {
				if (((newcallCommarea.getValue("MSG3I")).substring(0, 10)).equals("DATA ERROR")) {
					acctAmountTextField.requestFocus();
					information.setText(newcallCommarea.getValue("MSG3I"));
					eciRequest = null;
					return;
				}
			}
			if (((newcallCommarea.getValue("MSGI")).substring(0, 9)).equals("DUPLICATE")) {
				information.setText(newcallCommarea.getValue("MSGI"));
				acctNumber.requestFocus();
				((CardLayout)cardPanel.getLayout()).show(cardPanel, "main");
				eciRequest = null;
				return;
			}
			if ((newcallCommarea.getValue("MAPNAME")).equals("SENDTEXT")) {
				information.setText(newcallCommarea.getValue("TEXTAREA"));
				acctNumber.setText("");
				acctNumber.requestFocus();
				((CardLayout)cardPanel.getLayout()).show(cardPanel, "main");
				eciRequest = null;
				return;
			}
			acctNameLabel.setText(newcallCommarea.getValue("NAMEI"));
			acctAddressLabel.setText(newcallCommarea.getValue("ADDRI"));
			acctPhoneLabel.setText(newcallCommarea.getValue("PHONEI"));
			acctDateLabel.setText(newcallCommarea.getValue("DATEI"));
			acctAmountLabel.setText(newcallCommarea.getValue("AMOUNTI"));
			acctCommentLabel.setText(newcallCommarea.getValue("COMMENTI"));
			inqAcctNumberLabel.setText(newcallCommarea.getValue("NUMBI"));
			if ((addActionButton.getLabel()).equals("Update")) {
				information.setText("Account information updated");
			} else {
				information.setText("Account information added");
			}
			((CardLayout)cardPanel.getLayout()).show(cardPanel, "inquiry");
		} else {
			information.setText("Problem adding record, contact Tech Support.");
		}
		eciRequest = null;
		return;
	}  catch (IOException e) {
		printMsg(applName+": ERROR: " + e);
		try {
			if (CICSGatewayConnection != null) {
				CICSGatewayConnection.close();
				printMsg(applName+"Successfully closed JavaGateway");
				CICSGatewayConnection = null;
			}
		} catch (IOException eClose) {
			printMsg(applName+": Exception during close: " + eClose);
		}
		printMsg(applName+": ECI call exception: "+e);
		information.setText("Problem sending your request to CICS.");
		return;
	}
  }


 //------------------------------------------------------------------------------
 // - they hit the signon button, lets go do it
  private void signonInfo() {

    //-------------------------------------------------------------------------------
    // - verify that the userid and password are not null
        if ( (signonUserIdTextField.getText()).equals("") | (signonPasswordTextField.getText()).equals("") ) {
		information.setText("Userid and/or Password may not be null.");
		signonUserIdTextField.requestFocus();
		return;
	}
    //-------------------------------------------------------------------------------
    // - verify we are connected to the CICS Gateway for Java, else give error mesage
	if (!connectToGateway()) {
		Frame errF = new Frame(applName+" Error");
		Dialog errorD = new ErrPan(errF, "Cannot connect to the CICS Java Gateway, contact your system support.");
		errF.dispose();
		errF = null;
		information.setText("Problem connecting to the CICS Gateway for Java.");
		return;
	}
    //---------------------------------------------------------------------------
    // - drive the mainframe signon program
	String[] signonCommareaDescription = {
	//--->    fld Name   type len  initial value
	//--->  ------------ ---- ---  -----------------
		"VERSION",   "N", "2",  "",
		"RESP",      "N", "5",  "",
		"RESP2",     "N", "5",  "",
		"CICS-USER", "C", "8",  "",
		"CICS-PW",   "C", "8",  "",
		"DAYSLEFT",  "N", "8",  "",
		"ESMREASON", "N", "8",  "",
		"ESMRESP",   "N", "8",  "",
		"LASTDATE",  "C", "8",  "",
		"LASTTIME",  "C", "8",  "",
		"CLNTNAME",  "C", "4",  "",
		"FILLER",    "C", "28", "",
		"END-OF-ITEMS" };
	Commarea signonCommarea = new Commarea(signonCommareaDescription);
	signonCommarea.setValue("CICS-USER", signonUserIdTextField.getText());
	signonCommarea.setValue("CICS-PW", signonPasswordTextField.getText());
	//signonCommarea.toString();
	//System.out.println("-->"+new String(signonCommarea.theCommarea())+"<--");

	bTempCommarea = signonCommarea.theCommarea();
	try {
		printMsg(applName+": Trying ECI request for signon");
		eciRequest = new ECIRequest(strServerName,	// CICS Server
			strUserId,				// UserId, null for none
			strPassword,				// Password, null for none
			strSignProg,				// Program name
			bTempCommarea,				// Commarea, null for none
			ECIRequest.ECI_NO_EXTEND,		// single call in LUW
			ECIRequest.ECI_LUW_NEW);
		eciRequest.Cics_Rc = 0;
		CICSGatewayConnection.flow(eciRequest);	// flow the ECI request
		printMsg(applName+":  Return code: " + eciRequest.Cics_Rc);
		if (eciRequest.Cics_Rc == 0) {
			printMsg(applName+": entering if statement");
			signonCommarea.resetCommareaValues(bTempCommarea);  //return values
			printMsg(applName+": commarea object updated");
			//signonCommarea.toString();
			//System.out.println("Value of resp="+signonCommarea.getValue("RESP"));
			if ((signonCommarea.getValue("RESP")).equals("00000")) {
				printMsg(applName+": Resp was 0, uid and pw");
				strAuthenticatedUserId = signonUserIdTextField.getText();
				strAuthenticatedPassword = signonPasswordTextField.getText();
				information.setText("Signon complete");
				((CardLayout)cardPanel.getLayout()).show(cardPanel, "main");
				acctNumber.requestFocus();
				return;
			} else {
				printMsg(applName+": password validation failed with rc="+signonCommarea.getValue("RESP"));
				information.setText("Password validation problem, please retry.");
				signoffInfo();
				return;
			}
		} else {
			strAuthenticatedUserId = null;
			strAuthenticatedPassword = null;
			information.setText("Problem sending password validation request, contact Tech Support");
			((CardLayout)cardPanel.getLayout()).show(cardPanel, "signon");
			signonUserIdTextField.setText("");
			signonPasswordTextField.setText("");
			signonUserIdTextField.requestFocus();
		}
		eciRequest = null;
		return;
	}  catch (IOException e) {
		printMsg(applName+": ERROR: " + e);
		try {
			if (CICSGatewayConnection != null) {
				CICSGatewayConnection.close();
				printMsg(applName+"Successfully closed JavaGateway");
				CICSGatewayConnection = null;
			}
		} catch (IOException eClose) {
			printMsg(applName+": Exception during close: " + eClose);
		}
		printMsg(applName+": ECI call exception: "+e);
		information.setText("Problem sending your userid and password.");
		signoffInfo();
		return;
	}
  }
    
  private void signoffInfo() {
    strAuthenticatedUserId = null;
    strAuthenticatedPassword = null;
    information.setText("");
    ((CardLayout)cardPanel.getLayout()).show(cardPanel, "signon");
    signonUserIdTextField.setText("");
    signonPasswordTextField.setText("");
    signonUserIdTextField.requestFocus();
  }

//------------------------------------------------------------------------------------------
// -  this is the browse
  private void brwAcctInfo() {
    printMsg(applName+": This is the browse routine");
    printMsg(applName+": value of accNumber.getText() is "+acctNumber.getText());
	if (!connectToGateway()) {
		Frame errF = new Frame(applName+" Error");
		Dialog errorD = new ErrPan(errF, "Cannot connect to the CICS Java Gateway, contact your system support.");
		errF.dispose();
		errF = null;
		information.setText("Problem connecting to the CICS Gateway for Java.");
		return;
	}
    //---------------------------------------------------------------------------
    // - drive the mainframe browse program

	newcbrwCommarea.setValue("USRMAPLN", "1");
	newcbrwCommarea.setValue("USRTRNID", "BRWS");
	newcbrwCommarea.setValue("RETCODE", "0");
	newcbrwCommarea.setValue("KEYI", acctNumber.getText());
	newcallCommarea.setValue("KEYL", "6");

	if (sBrowseDirection.equals("Forward")) {
		newcbrwCommarea.setValue("CURROP", "F");
		newcbrwCommarea.setValue("USRAID", "1");    // pf1
		newcbrwCommarea.setValue("USRCALEN", "1");
		newcbrwCommarea.setValue("MAPNAME", "DETAIL");
	} else if (sBrowseDirection.equals("Backward")) {
		newcbrwCommarea.setValue("CURROP", "B");
		newcbrwCommarea.setValue("USRAID", "2");    // pf2
		newcbrwCommarea.setValue("USRCALEN", "1");
		newcbrwCommarea.setValue("MAPNAME", "DETAIL");
	} else if (sBrowseDirection.equals("Start")) {
		newcbrwCommarea.setValue("CURROP", "F");
		newcbrwCommarea.setValue("RIDF", acctNumber.getText());
		newcbrwCommarea.setValue("RIDB", acctNumber.getText());
		newcbrwCommarea.setValue("USRAID", "'");   // enter key
		newcbrwCommarea.setValue("USRCALEN", "0");
		newcbrwCommarea.setValue("MAPNAME", "MENU");
	} else {
		printMsg(applName+": invalid browse direction");
	}
		

	bTempCommarea = newcbrwCommarea.theCommarea();
	try {
		printMsg(applName+": Trying ECI request for newcbrw");
		eciRequest = new ECIRequest(strServerName,	// CICS Server
		strAuthenticatedUserId,				// UserId, null for none
		strAuthenticatedPassword,			// Password, null for none
		strBrowseProg,					// Program name
		bTempCommarea,					// Commarea, null for none
		ECIRequest.ECI_NO_EXTEND,			// last call in this LUW
		ECIRequest.ECI_LUW_NEW);			// first call in this LUW
		eciRequest.Cics_Rc = 0;
		CICSGatewayConnection.flow(eciRequest);	// flow the ECI request
		printMsg(applName+":  Return code: " + eciRequest.Cics_Rc);
		if (eciRequest.Cics_Rc == 0) {
			newcbrwCommarea.resetCommareaValues(bTempCommarea);  //return values

			
			if ((newcbrwCommarea.getByteValue("NUMBER1I"))[0] != 0x00) {
				browseNum1Label.setText(newcbrwCommarea.getValue("NUMBER1I"));
				browseNam1Label.setText(newcbrwCommarea.getValue("NAME1I"));
				browseAmt1Label.setText(newcbrwCommarea.getValue("AMOUNT1I"));
			} else {
				browseNum1Label.setText("");
				browseNam1Label.setText("");
				browseAmt1Label.setText("");
			}
	
			if ((newcbrwCommarea.getByteValue("NUMBER2I"))[0] != 0x00) {
				browseNum2Label.setText(newcbrwCommarea.getValue("NUMBER2I"));
				browseNam2Label.setText(newcbrwCommarea.getValue("NAME2I"));
				browseAmt2Label.setText(newcbrwCommarea.getValue("AMOUNT2I"));
			} else {
				browseNum2Label.setText("");
				browseNam2Label.setText("");
				browseAmt2Label.setText("");
			}

			if ((newcbrwCommarea.getByteValue("NUMBER3I"))[0] != 0x00) {
				browseNum3Label.setText(newcbrwCommarea.getValue("NUMBER3I"));
				browseNam3Label.setText(newcbrwCommarea.getValue("NAME3I"));
				browseAmt3Label.setText(newcbrwCommarea.getValue("AMOUNT3I"));
			} else {
				browseNum3Label.setText("");
				browseNam3Label.setText("");
				browseAmt3Label.setText("");
			}

			if ((newcbrwCommarea.getByteValue("NUMBER4I"))[0] != 0x00) {
				browseNum4Label.setText(newcbrwCommarea.getValue("NUMBER4I"));
				browseNam4Label.setText(newcbrwCommarea.getValue("NAME4I"));
				browseAmt4Label.setText(newcbrwCommarea.getValue("AMOUNT4I"));
			} else {
				browseNum4Label.setText("");
				browseNam4Label.setText("");
				browseAmt4Label.setText("");
			}

			if (((newcbrwCommarea.getValue("MSG1I")).substring(0,6)).equals("HI-END")) {
				information.setText(newcbrwCommarea.getValue("MSG1I"));
				//eciRequest = null;
				//return;
			} else { if (((newcbrwCommarea.getValue("MSG2I")).substring(0,6)).equals("LO-END")) {
				information.setText(newcbrwCommarea.getValue("MSG2I"));
				//eciRequest = null;
				//return;
				} else {
					information.setText("Press return, forward, or previous buttons");
				}
			}
			((CardLayout)cardPanel.getLayout()).show(cardPanel, "browse");
		} else {
			information.setText("Browse retreival problem, call your tech support");
		}
		eciRequest = null;
		return;
	}  catch (IOException e) {
		printMsg(applName+": ERROR: " + e);
		try {
			if (CICSGatewayConnection != null) {
				CICSGatewayConnection.close();
				printMsg(applName+"Successfully closed JavaGateway");
				CICSGatewayConnection = null;
			}
		} catch (IOException eClose) {
			printMsg(applName+": Exception during close: " + eClose);
		}
		printMsg(applName+": ECI call exception: "+e);
		information.setText("Problem sending your request to CICS.");
		return;
	}
  }



}


/*********************************************************************************/
/**  This is a generic object to display a modal error dialog message            */
/*********************************************************************************/
class ErrPan extends Dialog implements ActionListener, WindowListener {

  Button bTheOKButton = new Button("OK");

  public ErrPan(Frame parentFrame, String errText) {
    super(parentFrame, " DSCApp Error Message", true);
    setLayout(new BorderLayout());

    // Error message
    Panel pan1 = new Panel();
    pan1.setLayout(new FlowLayout(FlowLayout.CENTER));
    pan1.add(new Label(errText));
    add("North",pan1);

    // Buttons
    Panel pan2 = new Panel();
    pan2.setLayout(new FlowLayout(FlowLayout.CENTER));
    pan2.add(bTheOKButton);
    bTheOKButton.addActionListener(this);
    add("South", pan2);

    addWindowListener(this);
    pack();
    show();
  }
  // Add dialog button listener
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == bTheOKButton) {
        dispose();
        return;
    }
  }

 // added cause we are a window listener
   public void windowOpened(WindowEvent e) {}
   public void windowClosing(WindowEvent e) {
      dispose();
      return;
   }
   public void windowClosed(WindowEvent e) {}
   public void windowIconified(WindowEvent e) {}
   public void windowDeiconified(WindowEvent e) {}
   public void windowActivated(WindowEvent e) {}
   public void windowDeactivated(WindowEvent e) {}
}


//********************************************************************************************/
//*   generic commarea class                                                                 */
//********************************************************************************************/
class Commarea {
  private Hashtable commareaHashtable = new Hashtable();  // key=field name, value=CommareaElement
  private Vector commareaVector = new Vector();           // field names in order
  private int iCommareaLength;

  public Commarea(String[] s) {
     int elementLength;
     int index = 0;
     String elementType;
     String elementValue;
     String sTemp;
     boolean moreEntries = true;
     int iDisplacement = 0;
     do {
        sTemp =s[index];
        if (!sTemp.equals("END-OF-ITEMS")) {
           commareaVector.addElement(sTemp);
           int iSize = (Integer.valueOf(s[index+2])).intValue();
           commareaHashtable.put(sTemp, new CommareaElement(sTemp, s[index+1], iSize, s[index+3], iDisplacement));
           index+=4;
           iDisplacement += iSize;
        } else {
           moreEntries = false;
        }
     } while (moreEntries);
     iCommareaLength = iDisplacement;
     commareaVector.trimToSize();
  }

  public String toString() {
	System.out.println("Commarea length = "+iCommareaLength);
	for (Enumeration e = commareaVector.elements() ; e.hasMoreElements() ;) {
		System.out.println(commareaHashtable.get(e.nextElement()));
	}
	return "";
  }

  public byte[] theCommarea() {
	//toString();
	byte[] bCommarea = new byte[iCommareaLength];
	String sElementName = "";
	byte[] bTemp;
	int comIndex1 = 0;
	for (Enumeration e = commareaVector.elements() ; e.hasMoreElements() ;) {
		sElementName = (String)e.nextElement();
		bTemp = ((CommareaElement)commareaHashtable.get(sElementName)).getByteValue();
		for (int i = 0; i < bTemp.length; i++) {
			bCommarea[comIndex1] = bTemp[i];
			comIndex1++;
		}
	}
	return bCommarea;
  }

  public void resetCommareaValues(byte[] bCommarea) {
     int beginIndex = 0;
     String sTemp;
     for (Enumeration e = commareaVector.elements() ; e.hasMoreElements() ;) {
        sTemp = (String)e.nextElement();
        //System.out.println("=> changing value of "+sTemp+" to ->"+new String(bCommarea, beginIndex, getLength(sTemp))+"<-");
        setValue(sTemp, new String(bCommarea, beginIndex, getLength(sTemp)));
        beginIndex += getLength(sTemp);
     }
  }

  public int length() { return iCommareaLength; }

  public int getLength(String elementName) {
	return ((CommareaElement)commareaHashtable.get(elementName)).getLength();
  }

  public String getValue(String elementName) {
	return ((CommareaElement)commareaHashtable.get(elementName)).getValue();
  }

  public byte[] getByteValue(String elementName) {
	return ((CommareaElement)commareaHashtable.get(elementName)).getByteValue();
  }

  public int getDisplacement(String elementName) {
	return ((CommareaElement)commareaHashtable.get(elementName)).getDisplacement();
  }

  public String setValue(String elementName, String value) {
	((CommareaElement)commareaHashtable.get(elementName)).setValue(value);
	return getValue(elementName);
  }

}

class CommareaElement {
	public  boolean bDebug = false;
	private int iSize;
	private int iDisplacement;
	private String sType;
	private String sValue;
	private String sName;

	public CommareaElement(String n, String t, int s, String v, int d) {
		sName = n;
		iSize = s;
		iDisplacement = d;
		if (t.equals("C") | t.equals("N") | t.equals("MFL")) {
			sType = t;
		} else {
			System.out.println("--> invalid value for commarea element type, assuming character (C).");
			sType = "C";
		}
		setValue(v);
	}

	public void printMsg(String s) { if (bDebug) {System.out.println(s);} }

	public String toString() { 
		return "--> Element name="+sName+", size="+iSize+", type="+sType+", value="+sValue+", disp ="+iDisplacement+"<--";
	}

	public int getLength() { return iSize; 	}

	public String getValue() { return sValue; }

	public byte[] getByteValue() {
		byte[] bTemp = new byte[iSize];
		if (sType.equals("C")) { return sValue.getBytes(); }
		else if (sType.equals("N")) { return sValue.getBytes(); }
		else if (sType.equals("MFL")) {
			int iTemp;
			try {
				iTemp = Integer.parseInt(sValue);
			} catch (NumberFormatException e) {
				//System.out.println("String="+sValue+" is an invalid number, assuming zero value");
				return bTemp;
			}
			for ( int i = 0; i < iSize; i++) {  // this only works for values up to 127
				if (i == iSize-1) {
					bTemp[i] = (byte)iTemp;
				} else {
					bTemp[i] = 0x00;
				}
			}
		} else {
			System.out.println("*** ERROR *** invalid data type encountered in CommareaElement.getByteValue");
		}
		return bTemp;
	}

	public int getDisplacement() { return iDisplacement; }

	public String getType() { return sType; }

	public String setValue(String v) {
		//printMsg("=> setting value:"+toString());
		if (sType.equals("C")) {
			sValue = (v+"                                                                                                                                                      ").substring(0,iSize);
		} 
		if (sType.equals("N")) {
			String sTemp = "000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"+v;
			int iTemp = sTemp.length() - iSize;
			//printMsg("length of sTemp="+sTemp.length()+", iSize="+iSize+", start="+iTemp);
			sValue = sTemp.substring(iTemp);
		}
		if (sType.equals("MFL")) {
			sValue = v;
		}
		printMsg("=> value set:"+toString());
		return sValue;
	}
}
